include \masm32\include\masm32rt.inc

.data
cmpstrx db 'define',0
szLib	db 'RAHexEd.dll',0
szLibE  db 'RACad.dll',0
filename db 'winuser.h'
.data?
hInstance	dd ?
hNameBox 	dd ?
hHexBox 	dd ?
IndexItem	dd ?
buffer		db 10 dup(?)
hLib		dd	?
hLibE       dd  ?

.const
IDD_MAINDIALOG			equ 101
IDC_WMNAME 				equ 1002
IDC_WMHEX 				equ 1003
;Messages
FBM_SETPATH				equ WM_USER+1	;wParam=FALSE/TRUE(Refresh), lParam=Pointer to path string
FBM_GETPATH				equ WM_USER+2	;wParam=0, lParam=Pointer to path string
FBM_SETFILTERSTRING		equ WM_USER+3	;wParam=FALSE/TRUE(Refresh), lParam=Pointer to filter string
FBM_GETFILTERSTRING		equ WM_USER+4	;wParam=0, lParam=Pointer to filter string
FBM_SETFILTER			equ WM_USER+5	;wParam=FALSE/TRUE(Refresh), lParam=FALSE/TRUE(Filter On/Off)
FBM_GETFILTER			equ WM_USER+6	;wParam=0, lParam=0
FBM_SETSELECTED			equ WM_USER+7	;wParam=0, lParam=lpFile
FBM_GETSELECTED			equ WM_USER+8	;wParam=0, lParam=lpFile
FBM_SETBACKCOLOR		equ WM_USER+9	;wParam=0, lParam=nColor
FBM_GETBACKCOLOR		equ WM_USER+10	;wParam=0, lParam=0
FBM_SETTEXTCOLOR		equ WM_USER+11	;wParam=0, lParam=nColor
FBM_GETTEXTCOLOR		equ WM_USER+12	;wParam=0, lParam=0

;Proc
DlgProc   PROTO	  :HWND,:UINT,:WPARAM,:LPARAM

.code

ParseFile proc hWin:HWND,fname:DWORD

	LOCAL hMem  :DWORD                          ;loaded file memory
	LOCAL flen  :DWORD                          ;loaded file length
	LOCAL hBuf  :DWORD                          ;buffer handle
	LOCAL rpos  :DWORD                          ;pointer to next read position
	LOCAL hArr  :DWORD                          ;array handle
	LOCAL pmain :DWORD                          ;array main memory handle
	LOCAL acnt  :DWORD                          ;count of arguments returned by tokeniser
                                                                          
	invoke GetDlgItem,hWin,1002
	mov	hNameBox,eax
	invoke GetDlgItem,hWin,1003
	mov	hHexBox,eax	
	mov hMem, InputFile(fname)           
    mov flen, ecx
    mov hBuf, alloc(flen)
    mov hArr, rv(create_array,64,1024)          
    mov pmain, ecx
    push esi
    mov rpos, 0   
stlp:
    mov rpos, rv(get_ml,hMem,hBuf,rpos)         
    cmp rpos, 0
    jz stout
    mov acnt, rv(parse_line,hBuf,hArr)         
    mov esi, hArr
@@:
  	 invoke szCmp,[esi],addr cmpstrx
  	 .if eax == 0
  	 	jmp skip
  	 .endif
	invoke	SendMessage,hNameBox,LB_ADDSTRING,0,[esi+4]  
	invoke	SendMessage,hHexBox,LB_ADDSTRING,0,[esi+8]           
skip:       
    add esi, 4
    sub acnt,1
    jnz @B
    jmp stlp
    stout:
    pop esi                                                    
    free hArr
    free pmain	
    free hMem
    free hBuf
	ret
ParseFile endp

start:

	invoke GetModuleHandle,NULL
	mov	   hInstance,eax
    invoke InitCommonControls
    invoke LoadLibrary,addr szLib
	mov	hLib,eax
	invoke LoadLibrary,addr szLibE
	mov	hLibE,eax
	invoke DialogBoxParam,hInstance,IDD_MAINDIALOG,NULL,addr DlgProc,NULL
	invoke FreeLibrary,hLib
	invoke FreeLibrary,hLibE
	invoke ExitProcess,0

;########################################################################


DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov	eax,uMsg
	.if eax==WM_INITDIALOG
		push ebx
		invoke  GetDlgItem,hWin,1006
		mov	ebx,eax
		invoke SendMessage,ebx,FBM_SETBACKCOLOR,0,0C0FFFFh
		invoke SendMessage,ebx,FBM_SETTEXTCOLOR,0,0C00000h
		invoke SendMessage,ebx,FBM_SETFILTER,TRUE,TRUE
		pop ebx
	
		invoke ParseFile,hWin,addr filename
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.elseif uMsg==WM_COMMAND
		mov	edx,wParam
		shr	edx,16
		.IF dx==LBN_SELCHANGE
		 invoke	SendMessage,[lParam],LB_GETCURSEL,0,0		  ;Get the cursors selection index
         mov IndexItem,eax
         invoke SendMessage,hNameBox,LB_SETCURSEL,IndexItem,0 ;Update both positions
  		 invoke SendMessage,hHexBox, LB_SETCURSEL,IndexItem,0
		.ENDIF
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret

DlgProc endp

end start
